﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Public Class Form1
   Private moLine As LineShape
   Private moPolygon As PolygonShape
   Private moMap As WinformsMap
   Private moShapefile As MyShapefile
   Private moInMemoryFeatureLayer As New InMemoryFeatureLayer
   '   Private moSelectionLayer As New InMemoryFeatureLayer
   Private WithEvents moEditOverlay As MyEditOverlay
   Private msKey As String
   Private moEditFeatures As New Collection(Of Feature)
   Public Const cdMICRON As Double = 0.000001

   Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
      Dim oLayerOverlay As New LayerOverlay
      Dim oSelectionOverlay As New LayerOverlay

      moMap = WinformsMap1
      moMap.MapUnit = GeographyUnit.Meter
      moMap.MinimumScale = 0
      ShapeFileFeatureLayer.BuildIndexFile("..\..\Data\TestPoly.shp", BuildIndexMode.DoNotRebuild)
      moShapefile = New MyShapefile("..\..\Data\TestPoly.shp", ShapeFileReadWriteMode.ReadOnly)

      Dim oProj4 = New ManagedProj4Projection(
                       ManagedProj4Projection.GetEsriParametersString(26916),
                       ManagedProj4Projection.GetEsriParametersString(26915))

      moShapefile.FeatureSource.Projection = oProj4

      oLayerOverlay.Layers.Add("Shapefile", moShapefile)

      Dim oAreaStyle As AreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.GeographicColors.InnerState, 1)
      moShapefile.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oAreaStyle)
      moShapefile.AreaSymbol = oAreaStyle

      Dim oTextStyle As TextStyle = TextStyles.Country1("Name")
      oTextStyle.DuplicateRule = LabelDuplicateRule.UnlimitedDuplicateLabels
      oTextStyle.OverlappingRule = LabelOverlappingRule.AllowOverlapping
      oTextStyle.LabelAllPolygonParts = True
      moShapefile.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oTextStyle)
      moShapefile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

      moShapefile.TextSymbol = oTextStyle
      moShapefile.Open()

      WinformsMap1.Overlays.Add(oLayerOverlay)
      moEditOverlay = New MyEditOverlay
      WinformsMap1.EditOverlay = moEditOverlay

      WinformsMap1.CurrentExtent = moShapefile.GetBoundingBox
      With moEditOverlay
         .CanAddVertex = False
         .CanDrag = False
         .CanRemoveVertex = False
         .CanReshape = True
         .CanResize = False
         .CanRotate = False
         .EditLayer = moShapefile
         .Map = WinformsMap1
         .CalculateAllControlPoints()
         .EditShapesLayer.Name = "EditShapesLayer"
      End With

      WinformsMap1.Refresh()

   End Sub


   Private Sub WinformsMap1_MapClick(ByVal sender As Object, ByVal e As ThinkGeo.MapSuite.DesktopEdition.MapClickWinformsMapEventArgs) Handles WinformsMap1.MapClick
      Dim oFeatures As Collection(Of Feature)
      If e.MouseButton = MapMouseButton.Left Then

         If msKey <> String.Empty Then
            With WinformsMap1.EditOverlay.EditShapesLayer
               .Open()
               .EditTools.IsTransactionLive = True
               .EditTools.BeginTransaction()
               .EditTools.Delete(msKey)
               .EditTools.CommitTransaction()
            End With
         End If

         '***** Select a feature
         oFeatures = moShapefile.QueryTools.GetFeaturesContaining(New PointShape(e.WorldX, e.WorldY), ReturningColumnsType.AllColumns)
         If oFeatures.Count > 0 Then
            msKey = oFeatures(0).Id
            With WinformsMap1.EditOverlay.EditShapesLayer
               .Open()
               .EditTools.IsTransactionLive = True
               .EditTools.BeginTransaction()
               .EditTools.Add(oFeatures(0))
               .EditTools.CommitTransaction()
            End With
         End If

         WinformsMap1.EditOverlay.CalculateAllControlPoints()
         WinformsMap1.Refresh()
      End If
   End Sub
End Class
